
-- + eat much honey to get buff that runs faster and restore sanity
--   eating petals has effect of eating honey
--   eating evil petals has double effect of eating honey
-- + she consume food as less quoter as normal.
-- - don't eat honey a long time to loss sanity
-- - dislike hat. on a hat to losing sanity.

local HoneyWidget = require "widgets/honeywidget"
local MakePlayerCharacter = require "prefabs/player_common"

local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/lmm.zip" ),
}

-- additional prefabs list
local prefabs = {
	"mcake","mgunpowder","msugar"

}

-- save and load
local function onsave(inst, data)
	data.honeypoint = inst.honeypoint
end
local function onload(inst, data)
	if data then
		if data.honeypoint then
			inst.honeypoint = data.honeypoint
		end
	end
end

local function updateHoneyWidget(inst)
	if inst.honeywidget == nil then
		if inst.HUD.controls.sidepanel then
			inst.honeywidget = HoneyWidget(inst)
			inst.honeywidget:SetPosition(0,-180,0)
			inst.honeywidget = inst.HUD.controls.sidepanel:AddChild(inst.honeywidget)
			inst.honeywidget.text:SetString("Honey:".. math.floor(inst.honeypoint) .."%");
		end
	else
		inst.honeywidget.text:SetString("Honey:".. math.floor(inst.honeypoint) .."%");
	end
end

local function onupdate(inst)
	local run_bonus = 1

	-- losing honey point
	inst.honeypoint = inst.honeypoint - inst.honeydt;
	if 100 < inst.honeypoint then
		-- honey overdrive consume double honey point
		run_bonus = run_bonus * 1.25
		inst.honeypoint = inst.honeypoint - inst.honeydt * 3;
	else
		-- not overdrive
		if 100-inst.honeydt <= inst.honeypoint then
			inst.components.talker:Say("more honey to run!")
		end

		if inst.honeypoint < 0 then 
			-- less than zero to decrease rate
			inst.honeypoint = inst.honeypoint + inst.honeydt * 0.8;
			if -inst.honeydt <= inst.honeypoint then
				inst.components.talker:Say("I need honey seriously!")
			end
			if inst.honeypoint < -50 then
				-- worst point
				inst.honeypoint = -50
			end
		end
	end
	updateHoneyWidget(inst)
	
	-- gunpowder boost
	if 0 < inst.boostpoint then
		run_bonus = run_bonus * 1.5
		inst.boostpoint = inst.boostpoint - 1
		if 1 == inst.boostpoint then
			inst.components.talker:Say("I'm tired.")
		end
	end
	
	inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED * run_bonus
end

local function getHoneyValue(food)
	-- define honey point of food
	print("gethoneyvalue")
	print(food.prefab)
	if food.prefab == "honey" then
		return 10
	elseif food.prefab == "petals" then
		return 5
	elseif food.prefab == "petals_evil" then
		return 10
	elseif food.prefab == "mcake" then
		return 100
	elseif food.prefab == "msugar" then
		return 5
	elseif food.prefab == "honeynuggets" then
		return 20
	elseif food.prefab == "honeyham" then
		return 20
	elseif food.prefab == "taffy" then
		return 40
	elseif food.prefab == "butterflymuffin" then
		return 20
	elseif food.prefab == "jammypreserves" then
		return 20
	elseif food.prefab == "waffles" then
		return 20
	elseif food.prefab == "fruitmedley" then
		return 20
	elseif food.prefab == "" then
		return 0
	end
		-- TODO add honeyly crockpot foods
	return 0
end

local function oneat(inst, food)
	-- add honeywidget
	
	-- get honey point
	local honeyvalue = getHoneyValue(food)
	if 0 < honeyvalue then
		inst.honeypoint = inst.honeypoint + honeyvalue
		if 150 < inst.honeypoint then
			inst.honeypoint = 150;
		end
	else 
		inst.honeypoint = inst.honeypoint - 1
	end
	-- check mgunpowder
	if food.prefab == "mgunpowder" then
		inst.components.talker:Say("I'm Booooost!")
		inst.boostpoint = 60
	end
	
end

local function sanityfn(inst)
	local sanitybuff = 0
	-- equip hat to lose sanity
	local hat = inst.components.inventory.equipslots[EQUIPSLOTS.HEAD];
	if hat ~= nil then
		if hat.prefab ~= "flowerhat" and hat.prefab ~= "earmuffshat" then
			sanitybuff = sanitybuff + TUNING.SANITY_NIGHT_LIGHT
		end
	end
	if inst.honeypoint < 0 then
		sanitybuff = sanitybuff + TUNING.SANITY_NIGHT_LIGHT;
	elseif 100 < inst.honeypoint then
		sanitybuff = sanitybuff - TUNING.SANITY_NIGHT_LIGHT;		
	end
	return sanitybuff
end


local fn = function(inst)
	-- honey value
	inst.honeypoint = 99
	inst.boostpoint = 0
	inst.honeydt = 25 / TUNING.TOTAL_DAY_TIME
	
	-- choose which sounds this character will play
	inst.soundsname = "wendy"
	-- a minimap icon must be specified
	inst.MiniMapEntity:SetIcon("lmmminimap.tex")
	-- todo: Add an example special power here.
	
	-- sanity penalty method
	inst.components.sanity.custom_rate_fn = sanityfn
	-- hanger(wilson_hunger_rate is 0.15625)
	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 0.75);

	-- regist oneat method
	inst.components.eater:SetOnEatFn(oneat)
	table.insert(inst.components.eater.foodprefs, "GUNPOWDER")

	
	-- regist save and load method
	inst.OnSave = onsave
	inst.OnLoad = onload
	
	--end
	
	-- add timer like task
	-- (event per sec , event function , first delay)
	inst:DoPeriodicTask(1,onupdate,1);
end

--40 sugars
--30 honeys
-- 2 gunpowder
-- 1 cake
local startitems = {
	"msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar",
	"msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar",
	"msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar",
	"msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar","msugar",
	"honey","honey","honey","honey","honey","honey","honey","honey","honey","honey",
	"honey","honey","honey","honey","honey","honey","honey","honey","honey","honey",
	"honey","honey","honey","honey","honey","honey","honey","honey","honey","honey",
	"mgunpowder","mgunpowder","mgunpowder","mcake",
}

STRINGS.CHARACTERS.LMM = require "speech_lmm"

return MakePlayerCharacter("lmm", prefabs, assets, fn, startitems)
